Index: /XIOS/dev/dev_olga/src/node/axis.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1025)
@@ -691,155 +918,142 @@
       }
 
-      list_msgsIndex.push_back(CMessage());
-      list_msgsIndex.back() << this->getId() << list_indi.back();
-
-      if (isCompressible_)
-      {
-        std::vector<int>& writtenIndSrc = indWrittenSrv_[rank];
-        list_writtenInd.push_back(CArray<int,1>(writtenIndSrc.size()));
-        CArray<int,1>& writtenInd = list_writtenInd.back();
-
-        for (n = 0; n < writtenInd.numElements(); ++n)
-          writtenInd(n) = writtenIndSrc[n];
-
-        list_msgsIndex.back() << writtenInd;
-      }
-
-      list_msgsVal.push_back(CMessage());
-      list_msgsVal.back() << this->getId() << list_val.back();
-
+      listData.push_back(CMessage());
+      listData.back() << this->getId()  
+                      << list_indi.back() << list_dataInd.back() << list_zoomInd.back() << list_mask.back()
+                      << hasValue;
+      if (hasValue)
+        listData.back() << list_val.back();
+      listData.back() << hasBounds_;
       if (hasBounds_)
-      {
-        list_msgsVal.back() << list_bounds.back();
-      }
-
-      eventIndex.push(rank, nbConnectedClients_[rank], list_msgsIndex.back());
-      eventVal.push(rank, nbConnectedClients_[rank], list_msgsVal.back());
-    }
-
-    client->sendEvent(eventIndex);
-    client->sendEvent(eventVal);
-  }
-
-  void CAxis::recvIndex(CEventServer& event)
-  {
-    CAxis* axis;
+        listData.back() << list_bounds.back();
+
+      eventData.push(rank, nbConnectedClients_[rank], listData.back());
+    }
+
+    client->sendEvent(eventData);
+  }
+
+  void CAxis::recvDistributedAttributes(CEventServer& event)
+  {
+    string axisId;
+    vector<int> ranks;
+    vector<CBufferIn*> buffers;
 
     list<CEventServer::SSubEvent>::iterator it;
     for (it = event.subEvents.begin(); it != event.subEvents.end(); ++it)
     {
+      ranks.push_back(it->rank);
       CBufferIn* buffer = it->buffer;
-      string axisId;
       *buffer >> axisId;
-      axis = get(axisId);
-      axis->recvIndex(it->rank, *buffer);
-    }
-
-    if (axis->isCompressible_)
-    {
-      std::sort(axis->indexesToWrite.begin(), axis->indexesToWrite.end());
-
+      buffers.push_back(buffer);
+    }
+    get(axisId)->recvDistributedAttributes(ranks, buffers);
+  }
+
+  void CAxis::recvDistributedAttributes(vector<int>& ranks, vector<CBufferIn*> buffers)
+  {
+    int nbReceived = ranks.size();
+    vector<CArray<int,1> > vec_indi(nbReceived), vec_dataInd(nbReceived), vec_zoomInd(nbReceived);    
+    vector<CArray<bool,1> > vec_mask(nbReceived);
+    vector<CArray<double,1> > vec_val(nbReceived);
+    vector<CArray<double,2> > vec_bounds(nbReceived);
+    
+    for (int idx = 0; idx < nbReceived; ++idx)
+    {      
+      CBufferIn& buffer = *buffers[idx];
+      buffer >> vec_indi[idx];
+      buffer >> vec_dataInd[idx];
+      buffer >> vec_zoomInd[idx];
+      buffer >> vec_mask[idx];
+
+      buffer >> hasValue;
+      if (hasValue)
+        buffer >> vec_val[idx];
+      buffer >> hasBounds_;
+      if (hasBounds_)
+        buffer >> vec_bounds[idx];
+    }
+
+    int nbData = 0;
+    for (int idx = 0; idx < nbReceived; ++idx)
+    {
+      nbData += vec_indi[idx].numElements();
+    }
+    
+    index.resize(nbData);
+    CArray<int,1> nonCompressedData(nbData);    
+    mask.resize(nbData);
+    if (hasValue)
+      value.resize(nbData);
+    if (hasBounds_)
+      bounds.resize(2,nbData);
+
+    nbData = 0;
+    for (int idx = 0; idx < nbReceived; ++idx)
+    {
+      CArray<int,1>& indi = vec_indi[idx];
+      CArray<int,1>& dataIndi = vec_dataInd[idx];
+      CArray<bool,1>& maskIndi = vec_mask[idx];
+      int nb = indi.numElements();
+      for (int n = 0; n < nb; ++n)
+      {
+        index(nbData) = indi(n);
+        nonCompressedData(nbData) = (0 <= dataIndi(n)) ? nbData : -1;
+        mask(nbData) = maskIndi(n);
+        if (hasValue)
+          value(nbData) = vec_val[idx](n);
+        if (hasBounds_)
+        {
+          bounds(0,nbData) = vec_bounds[idx](0,n);
+          bounds(1,nbData) = vec_bounds[idx](1,n);
+        }
+        ++nbData;
+      }
+    }
+
+    int nbIndex = index.numElements();
+    int nbCompressedData = 0; 
+    for (int idx = 0; idx < nonCompressedData.numElements(); ++idx)
+    {
+      if (0 <= nonCompressedData(idx) && nonCompressedData(idx) < nbIndex)
+        ++nbCompressedData;        
+    }
+
+    data_index.resize(nbCompressedData);
+    nbCompressedData = 0;
+    for (int idx = 0; idx < nonCompressedData.numElements(); ++idx)
+    {
+      if (0 <= nonCompressedData(idx) && nonCompressedData(idx) < nbIndex)
+      {
+        data_index(nbCompressedData) = nonCompressedData(idx);
+        ++nbCompressedData;        
+      }
+    }
+
+    int nbZoomIndex = 0;
+    for (int idx = 0; idx < nbReceived; ++idx)
+    {
+      nbZoomIndex += vec_zoomInd[idx].numElements();
+    }
+
+    zoom_index.resize(nbZoomIndex);
+    nbZoomIndex = 0;
+    CArray<int,1>& zoom_Index_Tmp = this->zoom_index;
+    for (int idx = 0; idx < nbReceived; ++idx)
+    {      
+      CArray<int,1> tmp = zoom_Index_Tmp(Range(nbZoomIndex, nbZoomIndex + vec_zoomInd[idx].numElements()-1));
+      tmp = vec_zoomInd[idx];
+
+      nbZoomIndex += vec_zoomInd[idx].numElements();
+    }
+
+
+    {
       CContextServer* server = CContext::getCurrent()->server;
-      axis->numberWrittenIndexes_ = axis->indexesToWrite.size();
-      MPI_Allreduce(&axis->numberWrittenIndexes_, &axis->totalNumberWrittenIndexes_, 1, MPI_INT, MPI_SUM, server->intraComm);
-      MPI_Scan(&axis->numberWrittenIndexes_, &axis->offsetWrittenIndexes_, 1, MPI_INT, MPI_SUM, server->intraComm);
-      axis->offsetWrittenIndexes_ -= axis->numberWrittenIndexes_;
-    }
-  }
-
-  void CAxis::recvIndex(int rank, CBufferIn& buffer)
-  {
-    buffer >> indiSrv_[rank];
-
-    if (isCompressible_)
-    {
-      CArray<int, 1> writtenIndexes;
-      buffer >> writtenIndexes;
-      indexesToWrite.reserve(indexesToWrite.size() + writtenIndexes.numElements());
-      for (int i = 0; i < writtenIndexes.numElements(); ++i)
-        indexesToWrite.push_back(writtenIndexes(i));
-    }
-  }
-
-  void CAxis::recvDistributedValue(CEventServer& event)
-  {
-    list<CEventServer::SSubEvent>::iterator it;
-    for (it = event.subEvents.begin(); it != event.subEvents.end(); ++it)
-    {
-      CBufferIn* buffer = it->buffer;
-      string axisId;
-      *buffer >> axisId;
-      get(axisId)->recvDistributedValue(it->rank, *buffer);
-    }
-  }
-
-  void CAxis::recvDistributedValue(int rank, CBufferIn& buffer)
-  {
-    CArray<int,1> &indi = indiSrv_[rank];
-    CArray<double,1> val;
-    CArray<double,2> boundsVal;
-
-    buffer >> val;
-    if (hasBounds_) buffer >> boundsVal;
-
-    int i, j, ind_srv;
-    for (int ind = 0; ind < indi.numElements(); ++ind)
-    {
-      i = indi(ind);
-      ind_srv = i - zoom_begin_srv;
-      value_srv(ind_srv) = val(ind);
-      if (hasBounds_)
-      {
-        bound_srv(0,ind_srv) = boundsVal(0, ind);
-        bound_srv(1,ind_srv) = boundsVal(1, ind);
-      }
-    }
-  }
-
-   void CAxis::recvNonDistributedValue(CEventServer& event)
-  {
-    CAxis* axis;
-
-    list<CEventServer::SSubEvent>::iterator it;
-    for (it = event.subEvents.begin(); it != event.subEvents.end(); ++it)
-    {
-      CBufferIn* buffer = it->buffer;
-      string axisId;
-      *buffer >> axisId;
-      axis = get(axisId);
-      axis->recvNonDistributedValue(it->rank, *buffer);
-    }
-
-    if (axis->isCompressible_)
-    {
-      std::sort(axis->indexesToWrite.begin(), axis->indexesToWrite.end());
-
-      axis->numberWrittenIndexes_ = axis->totalNumberWrittenIndexes_ = axis->indexesToWrite.size();
-      axis->offsetWrittenIndexes_ = 0;
-    }
-  }
-
-  void CAxis::recvNonDistributedValue(int rank, CBufferIn& buffer)
-  {
-    CArray<double,1> val;
-    buffer >> val;
-
-    for (int ind = 0; ind < val.numElements(); ++ind)
-    {
-      value_srv(ind) = val(ind);
-      if (hasBounds_)
-      {
-        bound_srv(0,ind) = bounds(0,ind);
-        bound_srv(1,ind) = bounds(1,ind);
-      }
-    }
-
-    if (isCompressible_)
-    {
-      CArray<int, 1> writtenIndexes;
-      buffer >> writtenIndexes;
-      indexesToWrite.reserve(indexesToWrite.size() + writtenIndexes.numElements());
-      for (int i = 0; i < writtenIndexes.numElements(); ++i)
-        indexesToWrite.push_back(writtenIndexes(i));
+      count_write_index_ = zoom_index.numElements();      
+      MPI_Scan(&count_write_index_, &start_write_index_, 1, MPI_INT, MPI_SUM, server->intraComm);
+      global_write_size_ = start_write_index_;
+      start_write_index_ -= count_write_index_;
+      local_write_size_ = count_write_index_;      
     }
   }
@@ -849,6 +1063,10 @@
   // {
   //   CContext* context = CContext::getCurrent();
-  //   CContextClient* client = context->client;
-  //   int nbServer = client->serverSize;
+
+  //   CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer 
+  //                                                                       : context->client;
+
+    
+  //   int nbServer = contextClientTmp->serverSize;
 
   //   CServerDistributionDescription serverDescription(globalDim, nbServer);
@@ -858,10 +1076,13 @@
   //   std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
 
+  //   globalDimGrid.resize(globalDim.size());
+  //   for (int idx = 0; idx < globalDim.size(); ++idx) globalDimGrid(idx) = globalDim[idx];
+
   //   CEventClient event(getType(),EVENT_ID_SERVER_ATTRIBUT);
-  //   if (client->isServerLeader())
+  //   if (contextClientTmp->isServerLeader())
   //   {
   //     std::list<CMessage> msgs;
 
-  //     const std::list<int>& ranks = client->getRanksServerLeader();
+  //     const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
   //     for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
   //     {
@@ -877,114 +1098,69 @@
   //       msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
   //       msg << isCompressible_;
+  //       msg << orderPositionInGrid;
+  //       msg << globalDimGrid;
 
   //       event.push(*itRank,1,msg);
   //     }
-  //     client->sendEvent(event);
+  //     contextClientTmp->sendEvent(event);
   //   }
-  //   else client->sendEvent(event);
+  //   else contextClientTmp->sendEvent(event);
   // }
 
-  void CAxis::sendServerAttribut(const std::vector<int>& globalDim, int orderPositionInGrid,
-                                 CServerDistributionDescription::ServerDistributionType distType)
-  {
-    CContext* context = CContext::getCurrent();
-    int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
-    for (int i = 0; i < nbSrvPools; ++i)
+  // void CAxis::recvServerAttribut(CEventServer& event)
+  // {
+  //   CBufferIn* buffer = event.subEvents.begin()->buffer;
+  //   string axisId;
+  //   *buffer >> axisId;
+  //   get(axisId)->recvServerAttribut(*buffer);
     {
       CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i]
-                                                                          : context->client;
-      int nbServer = contextClientTmp->serverSize;
-
-      CServerDistributionDescription serverDescription(globalDim, nbServer);
-      serverDescription.computeServerDistribution();
-
-      std::vector<std::vector<int> > serverIndexBegin = serverDescription.getServerIndexBegin();
-      std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
-
-      globalDimGrid.resize(globalDim.size());
-      for (int idx = 0; idx < globalDim.size(); ++idx) globalDimGrid(idx) = globalDim[idx];
-
-      CEventClient event(getType(),EVENT_ID_SERVER_ATTRIBUT);
-      if (contextClientTmp->isServerLeader())
-      {
-        std::list<CMessage> msgs;
-
-        const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
-        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-        {
-          // Use const int to ensure CMessage holds a copy of the value instead of just a reference
-          const int begin = serverIndexBegin[*itRank][orderPositionInGrid];
-          const int ni    = serverDimensionSizes[*itRank][orderPositionInGrid];
-          const int end   = begin + ni - 1;
-
-          msgs.push_back(CMessage());
-          CMessage& msg = msgs.back();
-          msg << this->getId();
-          msg << ni << begin << end;
-          msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
-          msg << isCompressible_;
-          msg << orderPositionInGrid;
-          msg << globalDimGrid;
-
-          event.push(*itRank,1,msg);
-        }
-        contextClientTmp->sendEvent(event);
-      }
-      else contextClientTmp->sendEvent(event);
-    }
-  }
-
-  void CAxis::recvServerAttribut(CEventServer& event)
-  {
-    CBufferIn* buffer = event.subEvents.begin()->buffer;
-    string axisId;
-    *buffer >> axisId;
-    get(axisId)->recvServerAttribut(*buffer);
-
-    CContext* context = CContext::getCurrent();
-    if (context->hasClient && context->hasServer)
-    {
-      std::vector<int> globalDim(get(axisId)->globalDimGrid.numElements());
-      for (int idx = 0; idx < globalDim.size(); ++idx) globalDim[idx] = get(axisId)->globalDimGrid(idx);
-      get(axisId)->sendServerAttribut(globalDim, get(axisId)->orderPosInGrid, 
-                                      CServerDistributionDescription::BAND_DISTRIBUTION);
-    }
-  }
-
-  void CAxis::recvServerAttribut(CBufferIn& buffer)
-  {
-    int ni_srv, begin_srv, end_srv, global_zoom_begin_tmp, global_zoom_n_tmp;
-
-    buffer >> ni_srv >> begin_srv >> end_srv;
-    buffer >> global_zoom_begin_tmp >> global_zoom_n_tmp;
-    buffer >> isCompressible_;
-    buffer >> orderPosInGrid;
-    buffer >> globalDimGrid;
-
-    global_zoom_begin = global_zoom_begin_tmp;
-    global_zoom_n  = global_zoom_n_tmp;
-    int global_zoom_end = global_zoom_begin + global_zoom_n - 1;
-
-    zoom_begin_srv = global_zoom_begin > begin_srv ? global_zoom_begin : begin_srv ;
-    zoom_end_srv   = global_zoom_end < end_srv ? global_zoom_end : end_srv ;
-    zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
-
-    if (zoom_size_srv<=0)
-    {
-      zoom_begin_srv = 0; zoom_end_srv = 0; zoom_size_srv = 0;
-    }
-
-    if (n_glo == n)
-    {
-      zoom_begin_srv = global_zoom_begin;
-      zoom_end_srv   = global_zoom_end; //zoom_end;
-      zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
-    }
-    if (hasValue)
-    {
-      value_srv.resize(zoom_size_srv);
-      if (hasBounds_)  bound_srv.resize(2,zoom_size_srv);
-    }
-  }
+    }
+
+  //   CContext* context = CContext::getCurrent();
+  //   if (context->hasClient && context->hasServer)
+  //   {
+  //     std::vector<int> globalDim(get(axisId)->globalDimGrid.numElements());
+  //     for (int idx = 0; idx < globalDim.size(); ++idx) globalDim[idx] = get(axisId)->globalDimGrid(idx);
+  //     get(axisId)->sendServerAttribut(globalDim, get(axisId)->orderPosInGrid, 
+  //                                     CServerDistributionDescription::BAND_DISTRIBUTION);
+  //   }
+  // }
+
+  // void CAxis::recvServerAttribut(CBufferIn& buffer)
+  // {
+  //   int ni_srv, begin_srv, end_srv, global_zoom_begin_tmp, global_zoom_n_tmp;
+
+  //   buffer >> ni_srv >> begin_srv >> end_srv;
+  //   buffer >> global_zoom_begin_tmp >> global_zoom_n_tmp;
+  //   buffer >> isCompressible_;
+  //   buffer >> orderPosInGrid;
+  //   buffer >> globalDimGrid;
+
+  //   global_zoom_begin = global_zoom_begin_tmp;
+  //   global_zoom_n  = global_zoom_n_tmp;
+  //   int global_zoom_end = global_zoom_begin + global_zoom_n - 1;
+
+  //   zoom_begin_srv = global_zoom_begin > begin_srv ? global_zoom_begin : begin_srv ;
+  //   zoom_end_srv   = global_zoom_end < end_srv ? global_zoom_end : end_srv ;
+  //   zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
+
+  //   if (zoom_size_srv<=0)
+  //   {
+  //     zoom_begin_srv = 0; zoom_end_srv = 0; zoom_size_srv = 0;
+  //   }
+
+  //   if (n_glo == n)
+  //   {
+  //     zoom_begin_srv = global_zoom_begin;
+  //     zoom_end_srv   = global_zoom_end; //zoom_end;
+  //     zoom_size_srv  = zoom_end_srv - zoom_begin_srv + 1;
+  //   }
+  //   if (hasValue)
+  //   {
+  //     value_srv.resize(zoom_size_srv);
+  //     if (hasBounds_)  bound_srv.resize(2,zoom_size_srv);
+  //   }
+  // }
 
   CTransformation<CAxis>* CAxis::addTransformation(ETranformationType transType, const StdString& id)
@@ -1007,18 +1183,4 @@
   {
     return transformationMap_;
-  }
-
-  /*!
-    Check the validity of all transformations applied on axis
-  This functions is called AFTER all inherited attributes are solved
-  */
-  void CAxis::checkTransformations()
-  {
-    TransMapTypes::const_iterator itb = transformationMap_.begin(), it,
-                                  ite = transformationMap_.end();
-//    for (it = itb; it != ite; ++it)
-//    {
-//      (it->second)->checkValid(this);
-//    }
   }
 
Index: /XIOS/dev/dev_olga/src/node/axis.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/axis.hpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/node/axis.hpp	(revision 1025)
@@ -48,5 +48,7 @@
            EVENT_ID_INDEX,
            EVENT_ID_DISTRIBUTED_VALUE,
-           EVENT_ID_NON_DISTRIBUTED_VALUE
+           EVENT_ID_NON_DISTRIBUTED_VALUE,
+           EVENT_ID_NON_DISTRIBUTED_ATTRIBUTES,
+           EVENT_ID_DISTRIBUTED_ATTRIBUTES
          } ;
 
@@ -76,4 +78,9 @@
          int getOffsetWrittenIndexes() const;
 
+         int getStartWriteIndex() const;
+         int getCountWriteIndex() const;
+         int getLocalWriteSize() const;
+         int getGlobalWriteSize() const;
+
          std::map<int, StdSize> getAttributesBufferSize();
 
@@ -101,9 +108,9 @@
          static ENodeType GetType(void);
 
-         void sendServerAttribut(const std::vector<int>& globalDim, int orderPositionInGrid,
-                                 CServerDistributionDescription::ServerDistributionType distType);
+         // void sendServerAttribut(const std::vector<int>& globalDim, int orderPositionInGrid,
+         //                         CServerDistributionDescription::ServerDistributionType distType);
          static bool dispatchEvent(CEventServer& event);
          static void recvServerAttribut(CEventServer& event);
-         void recvServerAttribut(CBufferIn& buffer) ;
+         // void recvServerAttribut(CBufferIn& buffer) ;
          void checkAttributesOnClient();
          void checkAttributesOnClientAfterTransformation(const std::vector<int>& globalDim, int orderPositionInGrid,
@@ -134,18 +141,16 @@
          void checkMask();
          void checkZoom();
-         void checkBounds();
-         void checkTransformations();
-         void sendValue();
+         void checkBounds();         
+         void sendAttributes();
          void computeConnectedServer(const std::vector<int>& globalDim, int orderPositionInGrid,
                                      CServerDistributionDescription::ServerDistributionType distType);
-         void sendDistributedValue();
-         void sendNonDistributedValue();
 
-         static void recvIndex(CEventServer& event);
-         static void recvDistributedValue(CEventServer& event);
-         static void recvNonDistributedValue(CEventServer& event);
-         void recvIndex(int rank, CBufferIn& buffer);
-         void recvDistributedValue(int rank, CBufferIn& buffer);
-         void recvNonDistributedValue(int rank, CBufferIn& buffer);
+         void sendNonDistributedAttributes(void);
+         void sendDistributedAttributes(void);
+
+         static void recvNonDistributedAttributes(CEventServer& event);
+         static void recvDistributedAttributes(CEventServer& event);
+         void recvNonDistributedAttributes(int rank, CBufferIn& buffer);
+         void recvDistributedAttributes(vector<int>& rank, vector<CBufferIn*> buffers);
 
          void setTransformations(const TransMapTypes&);
@@ -161,6 +166,7 @@
          bool isCompressible_;
          std::map<int,int> nbConnectedClients_; // Mapping of number of communicating client to a server
-         std::map<int, vector<size_t> > indSrv_; // Global index of each client sent to server
+         boost::unordered_map<int, vector<size_t> > indSrv_; // Global index of each client sent to server
          std::map<int, vector<int> > indWrittenSrv_; // Global written index of each client sent to server
+         boost::unordered_map<size_t,size_t> globalLocalIndexMap_;
          std::vector<int> indexesToWrite;
          int numberWrittenIndexes_, totalNumberWrittenIndexes_, offsetWrittenIndexes_;
@@ -168,4 +174,9 @@
          std::map<int, CArray<int,1> > indiSrv_;
          bool hasBounds_;
+
+         int start_write_index_;
+         int count_write_index_;
+         int local_write_size_;
+         int global_write_size_;
 
        private:
